import io.gitlab.jfronny.scripts.*

plugins {
    id("jfmod")
    id("com.matthewprenger.cursegradle")
}

curseforge {
    if (System.getenv().containsKey("CURSEFORGE_API_TOKEN")) apiKey = System.getenv()["CURSEFORGE_API_TOKEN"]
    else println("No CURSEFORGE_API_TOKEN specified")
    project {
        id = prop("curseforge_id")
        releaseType = versionType.curseforgeName
        addGameVersion("Fabric")
        addGameVersion(lom.minecraftVersion.get())
        changelog = project.changelog
        mainArtifact(tasks.remapJar.get()) {
            displayName = "[${lom.minecraftVersion.get()}] $versionS"
        }
        relations {
            prop("curseforge_required_dependencies", "")
                .split(", ", ",")
                .filter { it.isNotBlank() }
                .forEach { requiredDependency(it) }
            prop("curseforge_optional_dependencies", "")
                .split(", ", ",")
                .filter { it.isNotBlank() }
                .forEach { optionalDependency(it) }
        }
    }
    options {
        forgeGradleIntegration = false
    }
}

tasks.deployRelease.dependsOn(tasks.curseforge)
