package io.gitlab.jfronny.scripts

import net.fabricmc.loom.LoomGradleExtension
import org.gradle.api.Project
import org.gradle.api.provider.Property
import java.util.*

interface LomExtension {
    var yarnBuild: String?

    fun yarn(yarnBuild: String) {
        this.yarnBuild = Objects.requireNonNull(yarnBuild)
    }

    fun mojmap() {
        yarnBuild = null
    }

    val minecraftVersion: Property<String>
    val loaderVersion: Property<String>

    companion object {
        operator fun get(project: Project): LoomGradleExtension {
            return project.extensions.getByName("lom") as LoomGradleExtension
        }
    }
}